// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "AnimBmp.h", created on 30/06/99
 * descr : animated bitmap class
 */
// ----------------------------------------------------------------------------------

#ifndef AnimBmpH
#define AnimBmpH

// ----------------------------------------------------------------------------------
class AnimBitmapBase {
    OkStuff(0xa817666);
    Block <Binder> datas;
    Block <int> indexes;
  protected:
    virtual Bitmap * createNew() = 0;
  public:
    virtual Bitmap * operator [] (int i);
    virtual Bitmap * find(XStr name);
    int add(XStr fileName);
    int size() { return indexes.size(); }
    AnimBitmapBase() { setId(); }
    virtual ~AnimBitmapBase();
};
// ----------------------------------------------------------------------------------
template <class ThisBitmap>
class AnimBitmap : public AnimBitmapBase {
  protected:
    virtual Bitmap * createNew() { return new ThisBitmap(); }
  public:
    virtual ThisBitmap * operator [] (int i) { return (ThisBitmap*) AnimBitmapBase::operator [] (i); }
    virtual ThisBitmap * find(XStr name)   { return (ThisBitmap*) AnimBitmapBase::find(name); }
};
// ----------------------------------------------------------------------------------

#endif // AnimBmpH


